package qh.lqg.utils;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * ClassName: Messages <br/>
 * Function: 从messages.properties文件获取配置信息（getString）. <br/>
 * date: 2016年8月6日 上午1:21:52 <br/>
 *
 * @author liuyuqi
 * @version
 * @since JDK 1.7
 */
public class Messages {
	private static final String BUNDLE_NAME = "qh.lqg.utils.messages"; //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

	private Messages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
