package qh.lqg.utils;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.ArrayList;

public class TextHelper {
	/**
	 * readTxt:(读取txt文档(一行一行读取)，返回String). <br/>
	 *
	 * @author liuyuqi
	 * @param dataUrl
	 *            文件路径（在项目根目录新建data文件夹放数据）
	 * @return
	 * @throws Exception
	 * @since JDK 1.7
	 */
	public String readTextByLine(String dataUrl) throws Exception {
		Reader reader = new InputStreamReader(new FileInputStream(dataUrl));
		BufferedReader br = new BufferedReader(reader);
		String data = "", line = null;
		while ((line = br.readLine()) != null) {
			data += line;
		}
		br.close();
		return data;
	}

	public ArrayList<String> readTextByWord(String dataUrl) throws Exception {
		ArrayList<String> list = new ArrayList<>();
		Reader reader = new InputStreamReader(new FileInputStream(dataUrl));
		BufferedReader br = new BufferedReader(reader);
		String data = "", line = null;
		while ((line = br.readLine()) != null) {
			data += line;
		}
		br.close();
		for (int i = 0; i < data.length(); i++) {
			list.add(data.substring(i, i + 1));
		}
		return list;
	}

	public static void writeText(String fileName, String content) {
		try {
			// 打开一个写文件器，构造函数中的第二个参数true表示以追加形式写文件
			FileWriter writer = new FileWriter(fileName, true);
			writer.write(content);
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
